use std::sync::Arc;
use axum::{Router, routing::{put, get}, Extension, middleware::from_fn};

use crate::state::ApiState;

mod app;
mod element;

pub fn get_router(state: ApiState) -> Router {
    Router::new()
    // authenticated routes
        .route("/element", put(element::create))
        .route("/element/:id", get(element::get).post(element::set).delete(element::remove))
        .layer(from_fn(app::auth))
    // public / unauthenticated routes
        .route("/app/register", put(app::register))
        .layer(Extension(Arc::new(state)))
}


